
/*
 * CNC MODULAR
 * Action : une pièce posée sur un axe CNC bouge de façon aléatoire.
 * Placer la pièce au milieu de l'axe.
 */
 
#include <Stepper.h>

int revolution = 200;  // 200 pas pour le NEMA17
int vitesse; // de 0 a 120
int tours;
int tabTours [] = { 20, 100, 30, 70 }; // doit etre pair
int tabVitesse [] = { 20, 90, 80, 40 }; 
int compteur = 0;
int nbValues = 4;
int maxTours = 0;

Stepper cnc (revolution, 9, 10, 11, 12);
// steps négatif = descente, positifs = montee

boolean DEBUG = true; // envois d'informations

void setup() {
  Serial.begin(9600);
}

void loop()
{
  if (compteur == nbValues ) {
    setRandomValues();
    compteur = 0;
    maxTours = 0;
    if (DEBUG) Serial.println("RESET");
  }
  
  // --------- MONTEE --------- //
  tours = tabTours[compteur];
  vitesse = tabVitesse[compteur];
  maxTours += tours;
  
   if (DEBUG) {
    Serial.println("***** MONTEE ******");
    Serial.print("vitesse : ");
    Serial.println(vitesse);
    Serial.print("tours : ");
    Serial.println(tours);
    Serial.print("max : ");
    Serial.println(maxTours);
  }
  
  cnc.setSpeed(vitesse);
  cnc.step(revolution * tours);
 
  delay(random(50,3000));
  
  
  // --------- DESCENTE --------- //
  tours = tabTours[(nbValues - 1) - compteur];
  vitesse = tabVitesse[(nbValues - 1) - compteur];
  maxTours += -tours;
  if (DEBUG) {
    Serial.println("***** DESCENTE ******");
    Serial.print("vitesse : ");
    Serial.println(vitesse);
    Serial.print("tours : ");
    Serial.println(tours);
    Serial.print("max : ");
    Serial.println(maxTours);
  }
  
  cnc.setSpeed(vitesse);
  cnc.step(-revolution * tours);
  
  delay(random(50,3000));
  
  compteur++;
}

void setRandomValues() {
  for (int i = 0; i < nbValues; i++) {
   int val = random(20, 120);
   tabVitesse[i] = val;
   tabTours[i] = map(val, 20, 120, 5, 140);
  }
}
